# frozen_string_literal: true

require 'cgi'
require 'forwardable'
require 'open3'
require 'pathname'
require 'uri'

require_relative 'repubmark/config'
require_relative 'repubmark/highlight'
require_relative 'repubmark/setup'
require_relative 'repubmark/titled_ref'

require_relative 'repubmark/elems/base'

# Top-level element
require_relative 'repubmark/elems/article'

# Always inside Article
require_relative 'repubmark/elems/annotation'
# Always inside Article, Chapter
require_relative 'repubmark/elems/chapter'
# Always inside Annotation, Blockquote, Chapter
require_relative 'repubmark/elems/canvas'

# Always inside Canvas
require_relative 'repubmark/elems/blockquote'
require_relative 'repubmark/elems/code_block'
require_relative 'repubmark/elems/figures'
require_relative 'repubmark/elems/iframe'
require_relative 'repubmark/elems/paragraph'
require_relative 'repubmark/elems/separator'

# Always inside Canvas, Figures
require_relative 'repubmark/elems/figure'
# Always inside Canvas, ListItem
require_relative 'repubmark/elems/list'
# Always inside List
require_relative 'repubmark/elems/list_item'

# Always inside Caption, Quote
require_relative 'repubmark/elems/joint'
# Always inside Blockquote, Figure, ListItem, Paragraph
require_relative 'repubmark/elems/caption'
# Always inside Caption, Joint, Quote
require_relative 'repubmark/elems/quote'

# Always inside Joint
require_relative 'repubmark/elems/abbrev'
require_relative 'repubmark/elems/code_inline'
require_relative 'repubmark/elems/fraction'
require_relative 'repubmark/elems/note'
require_relative 'repubmark/elems/section'
require_relative 'repubmark/elems/special'
require_relative 'repubmark/elems/text'
require_relative 'repubmark/elems/link'
